function Pinv = inv(P)

% INV -- inverse of polynomial matrix
%
%        Pinv = inv(P)
%
% I have chosen to invest all the programming effort into division
% of matrix polynomials, since P \ Q may succeed even if P has no
% inverse. As a side-effect, Pinv = P \ I.

% Copyright (c) 2004 by Fritz Keinert (keinert@iastate.edu),
% Dept. of Mathematics, Iowa State University, Ames, IA 50011.
% This software may be freely used and distributed for non-commercial
% purposes, provided this copyright statement is preserved, and
% appropriate credit for its use is given.
%
% Last update: Feb 20, 2004

[n1,n2] = size(P);
if (n1 ~= n2 | n1 == 0)
    error('inverse does not exist');
end

Pinv = P \ eye(n1);
