function yesno = ne(P1,P2)

% NE -- check matrix polynomials for non-equality
%
%       yesno = (P1 ~= P2)
%       yesno = ne(P1,P2)

% Copyright (c) 2004 by Fritz Keinert (keinert@iastate.edu),
% Dept. of Mathematics, Iowa State University, Ames, IA 50011.
% This software may be freely used and distributed for non-commercial
% purposes, provided this copyright statement is preserved, and
% appropriate credit for its use is given.
%
% Last update: Feb 20, 2004

[m1,m2] = size(P1);
[n1,n2] = size(P2);
if (m1 ~= n1 | m2 ~= n2)
    yesno = 1;
else
    yesno = ~iszero(P1-P2);
end
