function P = tril(P,varargin)

% TRIL -- set upper triangle in matrix polynomial to zero
%
%        P = tril(P)
%        P = tril(P,k)
%
% Set all values above the kth diagonal to zero. This extends
% the built-in TRIL function to matrix polynomials.

% Copyright (c) 2004 by Fritz Keinert (keinert@iastate.edu),
% Dept. of Mathematics, Iowa State University, Ames, IA 50011.
% This software may be freely used and distributed for non-commercial
% purposes, provided this copyright statement is preserved, and
% appropriate credit for its use is given.
%
% Last update: Feb 20, 2004

for i = 1:size(P.coef,3)
    P.coef(:,:,i) = tril(P.coef(:,:,i),varargin{:});
end
P = trim(P);
