function ind = index(n,i)

% INDEX -- turn scalar subscript into multidimensional subscript
%
% This routine cannot be called directly. It is private to the 
% @sym directory.
%
% For a matrix of size n = [n1,n2,...,nd], this routine returns a 
% cell vector of subscripts for the ith element

% Copyright (c) 2004 by Fritz Keinert (keinert@iastate.edu),
% Dept. of Mathematics, Iowa State University, Ames, IA 50011.
% This software may be freely used and distributed for non-commercial
% purposes, provided this copyright statement is preserved, and
% appropriate credit for its use is given.
%
% Last update: Feb 20, 2004

nstep = [1,cumprod(n)];
ii = i-1;
ind = cell(1,length(n));
for j = length(n):-1:1
    ind{j} = floor(ii/nstep(j))+1;
    ii = ii - (ind{j}-1) * nstep(j);
end

